//= require <dSS/ZonePanel>
//= require <dSS/grid/DevicePanel>
Ext.namespace('dSS');

dSS.ZoneBrowser = Ext.extend(Ext.Panel, {
    initComponent: function() {

        Ext.apply(this, {
            layout: 'border',
            items: [
            {
                xtype: 'dsszonepanel',
                ref: 'zonePanel',
                region: 'west',
                width: 225,
                // give east and west regions a width
                minSize: 175,
                maxSize: 400,
                split: true
            },
            {
                xtype: 'dssdevicepanel',
                ref: 'devicePanel',
                minSize: 400,
                region: 'center',
                featureConfig: dSS.config.FeatureConfig.ZONE
            }]
        });

        dSS.ZoneBrowser.superclass.initComponent.apply(this, arguments);

        this.on('afterrender', function() {
            if (dSS.config.firstLoad === true) {
                var fn = dSS.util.maskViewport.createDelegate(this, [ 'mask' ]);
                fn();
                dSS.data.Loader.load();
                dSS.config.firstLoad = false;
            }
        },
        this);

        this.on('activate', function() {
            if (this.zonePanel) {
                if (this.zonePanel.zoneView.getSelectionCount() === 0) {
                    var rec = this.zonePanel.zoneView.store.getById(0);
                    this.zonePanel.zoneView.select(rec);
                }
                this.zonePanel.zoneView.filterDevices();
                this.zonePanel.zoneView.updateNumDevicesHeader();
            }
            if (this.devicePanel) {
                this.devicePanel.handleSelection();
            }
        },
        this);

        dSS.MessageBus.on('reloadapartment',
            dSS.util.maskViewport.createDelegate(this, [ 'mask' ]),
            this);

        dSS.MessageBus.on('structureloaded',
            dSS.util.maskViewport.createDelegate(this, [ 'unmask' ]),
            this);
    },
    rescan: function() {
        this.el.mask(dSS._("Rescanning") + "...");
        Ext.Ajax.request({
            url: '/json/apartment/rescan',
            disableCaching: true,
            method: "GET",
            scope: this,
            success: function(result, request) {
                this.el.unmask();
                dSS.MessageBus.fireEvent('reloadapartment');
            },
            failure: function(result, request) {
                this.el.unmask();
                Ext.MessageBox.alert(dSS._("Error"), dSS._("Rescan failed"));
            }
        });
    }
});

Ext.reg('dsszonebrowser', dSS.ZoneBrowser);

